<script>
  export let route
  export let title

  import getGroupAuth from '../utils/getGroupAuth'
  import { getGroup, createGroup, updateGroup } from '../api/groups'
  import groups from '../stores/groups'
  import Form from '../components/Form'
  import localForage from 'localforage'

  $: groupId = parseInt(route.matches[1])
  $: group = $groups[groupId]
  $: $title = groupId
    ? group
      ? `Editar grupo ${group.name}`
      : 'Editar grupo'
    : 'Crear grupo'

  let auth
  function getInfo() {
    if (groupId) {
      return getGroupAuth(groupId).then(_auth => {
        auth = _auth
        if (!group) return getGroup(auth.id, auth.secret)
      })
    }
  }
  $: infoPromise = getInfo(groupId)

  function create(values) {
    return createGroup(values).then(group => {
      return localForage
        .getItem('groups')
        .then(groups => {
          groups = groups || []
          groups.push({ id: group.id, secret: group.secret })
          return localForage.setItem('groups', groups)
        })
        .then(() => {
          location.hash = `#/groups/${group.id}`
        })
    })
  }

  function update(values) {
    return updateGroup({ ...values, id: auth.id }, auth.secret).then(
      ({ group }) => (location.hash = `#/groups/${group.id}`),
    )
  }
</script>

{#await groupId && infoPromise}
  <p class="p-2 text-center">Cargando grupo...</p>
{:then}
  <Form
    values={{ name: { type: 'text', label: 'Nombre del grupo', props: { value: group && group.name, placeholder: 'Ejemplo: "Escuela 25 1ero"', required: true } }, submit: { type: 'submit', label: groupId ? 'Editar grupo' : 'Crear grupo!' } }}
    action={groupId ? update : create}
  />
{:catch error}
  <p class="p-2 text-center text-red-500">
    No se pudo conseguir ese grupo.
    <a class="link" href="#/groups">Volver atrás</a>
  </p>
{/await}
